/**************************************************************

	 xmalloc1.c 	 Z-World,  2004

    This program shows the basic functionality of the xmalloc
    dynamic xmemory  allocation system.

***************************************************************/

#use "XMALLOC.LIB"

#define  OBJSIZE 0x1000
#define  NOBJ  6

main()
{

	unsigned long addr[NOBJ];
   int i;

   // initialize xheap. Need an extra slot because of
   // call to xmalloc4kalign
	xheapInit(OBJSIZE,NOBJ+1);

   addr[0] = xmalloc4kalign(OBJSIZE);
   printf("4k aligned buffer allocated at %08lx\n\n",addr[0]);

	for (i=1;i<NOBJ;i++)
	{
      addr[i] = xmalloc(OBJSIZE);
	   printf("new  buffer allocated at %08lx\n",addr[i]);
	}
   printf("\n");

	for (i=1;i<NOBJ;i++)
	{
	   printf("freeing buffer at %08lx\n",addr[i]);
      xfree(addr[i]);
	}
   printf("\n");

	for (i=1;i<NOBJ;i++)
	{
      addr[i] = xmalloc(OBJSIZE);
	   printf("new  buffer allocated at %08lx\n",addr[i]);
	}
}


